



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java线程中断机制-如何中断线程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java线程中断机制-如何中断线程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 17:55:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>介绍：</h2>
<p>对于线程一共分为五个状态：新建状态，就绪状态，阻塞状态，运行状态，死亡状态，有时候把阻塞状态又分为同步阻塞和等待阻塞。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170806212646854?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvcXFfMzg2NjM3Mjk=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>有时想让主线程启动的一个子线程结束运行，我们就需要让这个子线程中断，不再继续执行。线程是有中断机制的，我们可以对每个线程进行中断标记，注意只是标记，中断与否还是虚拟机自己的事情，虚拟机自己家的事情，我们也就说说，不能实际操作控制他家。java中的Thread类是一个对线程进行操作的类，提供了中断线程的方法interrupt（），在API中是这么定义的（中文的翻译可能不准确）。</p>
<p>在Thread中其实还有一个stop（）方法也是中断线程的方法，但是这个方法太粗鲁了，人家好好的线程正在运行，只要调用了stop（）方法，线程就会中断，不管是在进行什么操作。这个方法已经被废弃，他的执行会带来一些不可确定的状况。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20171013200418195?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvcXFfMzg2NjM3Mjk=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>线程可以调用中断自己的方法interrupt（）方法，但是中断也是有条件的，在线程调用interrupt（）方法的时候虚拟机会在此线程上标记一个标志（这个中断标志只是一个布尔类型的变量），代表这个线程可能被中断，在后面的中断操作也是根据这个中断标志执行的。可以说interrupt（）方法是一种友好的方法，总是和虚拟机商量着来。如果一个线程处于了阻塞状态（如线程调用了sleep（）、join（）、wait（）、以及可中断的通道上的 I/O 操作方法后可进入阻塞状态），则在线程在检查中断标示时如果发现中断标示为true，则会在这些阻塞方法（sleep（）、join（）、wait（）及可中断的通道上的<br />
 I/O 操作方法）调用处抛出InterruptedException异常，并且在抛出异常后立即将线程的中断标示位清除，即重新设置为false。抛出异常是为了线程从阻塞状态醒过来，并在结束线程前让程序员有足够的时间来处理中断请求。</p>
<p>线程的一些状态都可能影响到这个中断标记从而结束中断。下面这个例子验证中断标志被除掉的说法</p>
<pre class="prettyprint linenums">package demo_thread;

public class Interrupt {<br />
    public static void main(String[] args) {<br />
        A a = new A();<br />
        Thread t1 = new Thread(a);<br />
        t1.start();<br />
        t1.interrupt();<br />
        System.out.println("执行睡眠之前1："+t1.isInterrupted());<br />
        try {<br />
            System.out.println("执行睡眠之前2："+t1.isInterrupted());<br />
            t1.sleep(1000);//线程进入阻塞状态<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        }finally {<br />
            System.out.println("执行睡眠之后："+t1.isInterrupted());<br />
        }<br />
    }<br />
}<br />
class A implements Runnable{

    @Override<br />
    public void run() {<br />
            System.out.println(Thread.currentThread());<br />
    }<br />
}</pre>
<p>在main方法中创建一个线程，线程中重写的run（）方法输出线程号，只是一个显示分隔，具体看在执行让线程阻塞方法之前和之后线程的中断标记。isInterrupted（）方法是判断线程是否执行中断的方法，就是判断中断标记是否存在的方法。</p>
<p>输出：</p>
<pre class="prettyprint linenums">执行睡眠之前1：true<br />
执行睡眠之前2：true<br />
Thread[Thread-0,5,main]<br />
执行睡眠之后：false</pre>
<p>可以看到只要执行了sleep（）方法，线程的中断标记就会被清除。分别调用执行了join（）、wait（）方法，可以看到他们的共同点都是需要捕获一个InterruptedException，在调用join（）方法的时候得到了和sleep（）方法一样的输出结果，但是在调用wait（）方法的时候，虽然在后面调用notify（）方法，但是是否获得执行权限还是无法预料的。<br /><br />
<br /><br />
中断一个线程只是为了引起该线程的注意，被中断线程可以决定如何应对中断，中断或者不中断。某些线程非常重要，以至于它们应该不理会中断，而是在处理完抛出的异常之后继续执行，但是更普遍的情况是，一个线程将把中断看作一个终止请求。<br /><br />
<br /><br />
两个很像的方法的区别：<br /><br />
<br /><br />
interrupted()：测试当前线程是否中断。 该方法可以清除线程的中断状态 。换句话说，如果这个方法被连续调用两次，那么第二个调用将返回false（除非当前线程再次中断，在第一个调用已经清除其中断状态之后，在第二个调用之前已经检查过）。<br /><br />
<br /><br />
isInterrupted()：测试这个线程是否被中断。线程的中断状态不受此方法的影响。</p>
<h2>如何中断线程：</h2>
<p>接下来看请求中断之后发生的事情：在网上看到一个例子</p>
<pre class="prettyprint linenums">package demo_thread;

public class Interrupt {<br />
        public static void main(String[] args) {<br />
            try {<br />
                MyThread thread = new MyThread();<br />
                thread.start();<br />
                Thread.sleep(2000);<br />
                thread.interrupt();//请求中断MyThread线程<br />
            } catch (Exception e) {<br />
                System.out.println("main catch");<br />
                e.printStackTrace();<br />
            }<br />
            System.out.println("end!");<br />
        }<br />
}<br />
class MyThread extends Thread {<br />
    @Override<br />
    public void run() {<br />
        super.run();<br />
        for (int i = 0; i &lt; 500000; i++) {<br />
            if (this.interrupted()) {<br />
                System.out.println("should be stopped and exit");<br />
                break;<br />
            }<br />
            System.out.println("i=" + (i + 1));<br />
        }<br />
        //尽管线程被中断,但并没有结束运行。这行代码还是会被执行<br />
        System.out.println("this line is also executed. thread does not stopped");<br />
    }<br />
}
</pre>
<p>在文章的开头处已经说了，线程执行中断方法，只是给线程一个中断标记，是否中断是他自己的事<br /><br />
<br /><br />
其中一次的输出：</p>
<pre class="prettyprint linenums">……<br />
i=75722<br />
end!<br />
should be stopped and exit<br />
this line is also executed. thread does not stopped</pre>
<p>由于线程执行了sleep（）方法，进入阻塞状态，所以在从阻塞状态从新回到运行状态的时候，发现自己已经有了中断标记，执行if中的语句，线程的睡眠和执行总是和计算机内部有关系，所以每次输出的结束数字总是不一样的。<br /><br />
<br /><br />
通过输出结果我们发现一个很重要的问题，我们要的是线程的中断，也就是关于线程的方法需要停止执行，但是在循环外面的输出语句也执行了，这个中断只是中断了循环的执行。<br /><br />
<br /><br />
<br /><br />
那么我们应该怎么中断线程呢？利用线程中断异常就是一个很好的办法，既然是异常，通常异常可以中断线程的运行，使程序挂掉，我们自己抛出一个异常让线程中断</p>
<pre class="prettyprint linenums">class MyThread extends Thread {<br />
    @Override<br />
    public void run() {<br />
        super.run();<br />
        try {<br />
            for (int i = 0; i &lt; 500000; i++) {<br />
                if (this.interrupted()) {<br />
                    System.out.println("should be stopped and exit");<br />
                    throw new InterruptedException();<br />
                }<br />
                System.out.println("i=" + (i + 1));<br />
            }<br />
            System.out.println("this line cannot be executed. cause thread throws exception");//这行语句不会被执行!!!<br />
        } catch (InterruptedException e) {<br />
            System.out.println("catch interrupted exception");<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
}</pre>
<p>输出：</p>
<pre class="prettyprint linenums">……<br />
i=131892<br />
should be stopped and exit<br />
end!</pre>
<p>但是通过抛出异常也带来了问题，我们不能通过抛出异常来处理问题，还需要在捕获异常的代码中加上处理的语句，例如保存用户的操作等等，让这次中断看起来是很正常的中断。<br /><br />
我们还可以通过让程序主动抛出异常，在线程阻塞的时候，执行中断操作，抛出异常，在循环中循环打印当前时间，</p>
<pre class="prettyprint linenums">package demo_thread;

import java.text.SimpleDateFormat;<br />
import java.util.Date;

public class SleepInterruptTest {<br />
    public static void main(String[] args) {<br />
        SleepThread t1 = new SleepThread();<br />
        t1.start();<br />
        try {<br />
            Thread.sleep(5000);<br />
        } catch (InterruptedException e) {

            e.printStackTrace();<br />
        }<br />
        t1.interrupt();//主动打断线程，使SleepThread线程抛出异常<br />
    }

}<br />
class SleepThread extends Thread{<br />
    public void run(){<br />
        while(true){<br />
            try{<br />
                SimpleDateFormat sim = new SimpleDateFormat("yyyy年MM月dd日 hh:mm:ss");<br />
                System.out.println(sim.format(new Date()));<br />
                sleep(1000);<br />
            }<br />
            catch(InterruptedException e){<br />
                System.out.println("线程中断");<br />
                return;<br />
            }<br />
        }<br />
    }<br />
}</pre>
<p>输出：</p>
<pre class="prettyprint linenums">2017年10月14日 10:40:01<br />
2017年10月14日 10:40:02<br />
2017年10月14日 10:40:03<br />
2017年10月14日 10:40:04<br />
2017年10月14日 10:40:05<br />
线程中断</pre>
<p>参考：http://www.cnblogs.com/hapjin/p/5450779.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495j50qz.html">分享一个MySQL分库分表备份脚本（原）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq155r69.html">FireBug提示：本页面不包含 JavaScript，明明是包含js的。</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qndlg38.html">对oracle数据库Blob字段的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4n5d9.html">crontab服务详解（任务计划）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvogvy8.html">java课后作业5</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oe04p9.html">SSAS：菜鸟笔记（二）定义计算（DMX脚本）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxplne9.html">【转】【Asp&period;Net】asp&period;net服务器控件创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jylxw9.html">【php学习】字符串操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmv2l69.html">java commons-lang 工具包 逃脱工具 转unicode 及其他</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmv67e9.html">mahout算法源码分析之Itembased Collaborative Filtering（三）RowSimilarityJob验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydl37jq.html">apache整合tomcat部署集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrnx3q.html">ubuntu 14&period;04 vnc use gnome&lpar;ubuntu14&period;04 gnome for vnc4server&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejo7e8.html">spring和redis的整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jk77w8.html">UVA 624 CD &lpar;01背包&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1klz069.html">hadoop2&period;8和spark2&period;1完全分布式搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mk6pj8.html">MeshRenderer组件及相关API</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgxvg78.html">sass补充（2019-3-9）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9600pn39.html">SFTP文件服务器的搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjolx59.html">C&num;事件の&period;net下的EventArgs和EventHandler</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyypxgjq.html">mybatis的update操作的几种动态更新</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jn2k38.html">java 集合类Array、List、Map区别和优缺点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge050l8.html">LitePal&mdash;&mdash;Android数据库框架完整使用手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkdz38.html">eclipse Maven配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjkg528.html">笔记︱集成学习Ensemble Learning与树模型、Bagging 和 Boosting</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jn65w8.html">一种在BIOS中嵌入应用程序的方法及实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1o70zq.html">VS2008下QT开发环境搭建&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jn6338.html">MySQL查看最大连接数和修改最大连接数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zwj219.html">insert  &comma;update 以及merge 的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z2wv39.html">SQL错误：ORA-12899</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjeyez8.html">Hive 编程之DDL、DML、UDF、Select总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
